/* This sample code is for HTTP POST application posting to Twitter
* using Arduino UNO and TAIYO YUDEN's WLAN Mmodule "WYSACVLXY-XX".
* This code doesn't tweet directly from your Arduino.
* It needs OAuth authentication through http://arduino-tweet.appspot.com/.
* You need to modify the variables as following:
* 1. Connection parameters for wireless access point (SSID...).
* 2. Your token
* 3. your message
* Refer to Aplication note in detail.
* TAIYO YUDEN CO., LTD. copyright 2016 
*/

#include <SoftwareSerial.h> // Include the Software Serial library.

// Define using SW Serial pins.
SoftwareSerial mySerial(10, 11); //RX, TX

// Define parameters
  // Wireless access point
    String ssId = "<< put your SSID here >>";
    String pass = "<< put your password here >>";
    // Securty: WPA2, IP: DHCP
  // Define the token obtained in http://arduino-tweet.appspot.com/.
    String token = "<< put your access token here >>";
  // Define the message to tweet.
    String msg = "Hello, World! I'm Arduino!";

// Define of the string buffer.
String res = "";

void setup() {
  // Setting of HW Serial (To display message from Arduino to PC)
  Serial.begin(9600);
  // Setting of SW Serial (Connect to WLAN module)
  mySerial.begin(9600);

  // Input connection parameter to access point.
  mySerial.print(F("WSTI101")); //SSID
  mySerial.println(ssId);
  mySerial.println(F("WSTI1024")); //security type: 4 = WPA2
  mySerial.print(F("WSTI103")); //password
  mySerial.println(pass);
  mySerial.println(F("WSTI1041")); //IP Addr: 1 = DHCP

  // Initial screen display.
  Serial.println(F("Wait a moment."));
  Serial.println(F("Now connecting.."));
  Serial.println(F(""));

  // Wait 10 seconds to connect to the access point.
  delay(10000);

  // HTTP POST for tweet.
  mySerial.print(F("WHPShttp://arduino-tweet.appspot.com/update"));
  mySerial.print(F("*token="));
  mySerial.print(token);
  mySerial.print(F("&status="));
  mySerial.println(msg);
 
}

void loop() {
  // Processing of message from WLAN module
  if (mySerial.available() > 0){
    char inChar = mySerial.read();
    if (inChar == '\n'){
      res += '\n';
      
      // WLAN message processing in disconnected or connected
      if (res.indexOf("RCT00") != -1){
        res.replace("RCT00", "");
        res.trim();
        Serial.println(res);
        res = "";
      } else if (res.indexOf("SOKError") != 1){
        res.replace("SOK", "");
        res.trim();
        Serial.println(res);
        res = "";
      } else if (res.indexOf("POK") != 1){
        Serial.println(F("Tweet success!"));
      // Fatal error
      } else if (res.indexOf("FTL") != -1) {
        // WLAN module soft reset
        mySerial.println(F("WRST"));
      }

      //Serial.println(res); // For debug
      res = "";
    } else {
      res += inChar;
    }
  }
}
